<?
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."template.php");
 require_once($_path["plugins"]."lister/lister.php");

 class photoalbum extends lister
 {
  function main()
  {
   global $_benchmark, $_photoalbumCommentSubmitted, $_config;

   if(!isset($this->config)||!$this->config)
    return false;

   //parse arguments
   if($this->config["listtype"]=="Photo albums")
   {
    //get arguments
    $args=request("p");
    array_shift($args);

    if($args) //list album, tags, dates or picture
    {
     $picture=false;
     foreach($args as $arg)
     {
      if($arg=="picture")
      {
       $picture=true;
       continue;
      }

      if($picture)
      {
       if(preg_match("/^\d+$/", $arg))
        $this->config["picture"]=$arg;
       else
        $this->config["tag"]=$arg;
      }
      else //albums
      {
       if(preg_match("/^\d+$/", $arg))
       {
        $this->config["album"]=$arg;
        $this->config["albums"]=$arg;
       }
       else
        $this->config["tag"]=$arg;
      }
     }
    }
    else //no arguments, show top level albums
     $this->config["albums"]=$this->config["listcatnr"];
   }

   $this->commentError=false;

   //only submit in photoalbum/item mode to ensure error is set to correct template
   if($this->config["listtype"]!="Photo albums"&&$this->config["listtype"]!="Item")
    return false;

   //ensure comments are only submitted once
   if($_photoalbumCommentSubmitted)
    return true;
   else
    $_photoalbumCommentSubmitted=true;

   //comment submit
   if($this->commentText=request("comment"))
   {
    if($_benchmark) $_benchmark->start("Submit comment");

    $d=Data::cache("photoalbum_comments", "add", "item");

    if($_config["usernr"]==$_config["anonnr"])
    {
     $d->addField("captcha", "captcha", "form", "", 0, 5, "", "Captcha");
     $d->setRequestValue("captcha");
    }

    $d->setValue("text", $this->commentText);
    $this->commentEntry=$d->getValue("photoalbumpicture");

    if(!$d->submit())
     $this->commentError=$d->e->show();

    if($_benchmark) $_benchmark->stop("Submit comment");
   }

   return true;
  }

  function _getData()
  {
   global $_benchmark;

   if(!isset($this->config)||!$this->config)
    return false;

   if($_benchmark) $_benchmark->start("Data object");

   if($this->config["listtype"]=="Photo albums")
   {
    $d=Data::cache("photoalbum_categories", "view", "all");
    $d->clearValues();

    if(isset($this->config["albums"])) //albums
     $d->setValue("catnr", $this->config["albums"]);
    if(isset($this->config["tag"])) //albums tag
     $d->setValue("tags", $this->config["tag"]);

    //display published or unpublished if user has edit rights
    $d->setValue("r", "00000000001", 2);
    $d->setOperator("r", "&", 2);
    $d->setOperant("r", "OR", 2);
    $d->setValue("published", true, 2);

    $d->sortOrder("date", "name");
   }
   else if($this->config["listtype"]=="List"||$this->config["listtype"]=="Item")
   {
    $d=Data::cache("photoalbum_pictures", "view", "all");
    $d->clearValues();

    //set show fields so lister->cache takes these in to account when checking cache
    $d->setShowFields("comments", "photoalbum_picturetagsmapping");
    $d->getReferenceData("comments")->setShowFields("text");
    $d->getReferenceData("photoalbum_picturetagsmapping")->getReferenceData("photoalbum_tags")->setShowFields("tag");

    $d->setValue("show_total", $this->config["listitems"]);

    if($this->config["pagebrowser"]) //only show "next page" if page browser is active
     $d->setValue("show_from", request("show_from"));

    if(isset($this->config["picture"])) //album
     $d->setValue("nr", $this->config["picture"]);
    else
    {
     if(isset($this->config["album"])) //album
      $d->setValue("catnr", $this->config["album"]);
     if(isset($this->config["tag"])) //pictures tag
      $d->setValue("tags", $this->config["tag"]);
    }

    //display published or unpublished if user has edit rights
    $d->reference["catnr"]["module"]="photoalbum_categories";
    unset($d->reference["catnr"]["data"]);

    $dtmp=$d->getReferenceData("catnr");
    $dtmp->setValue("r", "00000000001", 2);
    $dtmp->setOperator("r", "&", 2);
    $dtmp->setOperant("r", "OR", 2);
    $dtmp->setValue("published", true, 2);

    $d->sortOrder("date", "subject");
   }
   else if($this->config["listtype"]=="Crumb trail")
   {
    $d=Data::cache("photoalbum_categories", "tree", "up");
    $d->clearValues();

    if(($arg=request("p", 1))&&preg_match("/^\d+$/", $arg)) //album (/123/)
     $d->setValue("catnr", $arg);
    else
     $d->setValue("catnr", 0);
   }
   else if($this->config["listtype"]=="Latest comments") //Latest comments
   {
    $d=Data::cache("photoalbum_comments", "view", "all");
    $d->sortOrder("updated-");

    $d->clearValues();

    if($catnr=photoalbum_categories::getCategory("comments", $this->config["listcatnr"])) //get comments category
     $d->setValue("catnr", $catnr);
    else
     $d->setValue("catnr", $this->config["listcatnr"]);

    $d->setValue("show_total", $this->config["listitems"]);
   }
   else if($this->config["listtype"]=="Latest pictures") //Latest pictures
   {
    if(!($catnrs=photoalbum_categories::getCategory("albums", $this->config["listcatnr"]))) //get all photoalbum categories
     $catnrs=Array($this->config["listcatnr"]);

    //check if album are published
    $d=Data::cache("photoalbum_categories", "view", "all");
    $d->setShowFields("published");
    $d->clearValues();

    //get published or unpublished if user has edit rights
    foreach($catnrs as $key => $catnr)
    {
     $d->setValue("nr", $catnr, $key);
     $d->setOperant("nr", "OR", $key);
    }

    $catnrs=Array();
    if($d->get())
     while($d->next())
      if($d->v["published"]||$d->r("edit"))
       $catnrs[]=$d->v["nr"];

    $d=Data::cache("photoalbum_pictures", "view", "all");
    $d->sortOrder("updated-");

    $d->clearValues();

    if($catnrs)
    {
     foreach($catnrs as $k => $catnr)
     {
      $d->setValue("catnr", $catnr, $k);
      $d->setOperant("catnr", "OR", $k);
     }
    }
    else //no photoalbums
     $d->setValue("catnr", 1); //ensure no pictures are returned

    $d->setValue("show_total", $this->config["listitems"]);
   }
   else //tags cloud
   {
    $d=Data::cache("photoalbum_tags", "view", "all");
    $d->clearValues();
    $d->sortOrder("tag+");

    $d->setValue("catnr", $this->config["listcatnr"]);

    $d->field["cloud_size"]["min"]=6;
    $d->field["cloud_size"]["max"]=18;
    $d->field["cloud_size"]["type"]="nr";
   }

   if($_benchmark) $_benchmark->stop("Data object");

   return $d;
  }


  function cache(&$cacheTime, &$cacheKey)
  {
   global $_path, $_benchmark;

   //no caching on comment error
   if($this->commentError)
    return false;

   //templates updated (item, list and pagebrowser already handled in lister::cache)
   if($this->config["listtype"]=="Photo albums")
   {
    if($_benchmark) $_benchmark->start("Last update");

    $cacheKey.=$this->config["nr"]; //added config nr to cache key (prefix set by pager plugin)

    //custom _cacheKey
    if(isset($this->config["picture"]))
     $cacheKey.="_picture_".$this->config["picture"];
    else if(isset($this->config["album"]))
     $cacheKey.="_album_".$this->config["album"];

    if(isset($this->config["tag"]))
     $cacheKey.="_tag_".md5($this->config["tag"]);

    if(isset($this->config["picture"]))
    {
     $this->config["listtype"]="Item";

     $dc=$this->_getData();

     if(!$this->_cacheDataUpdated($cacheTime, $dc))
      return false;

     $this->config["listtype"]="Photo albums";
    }
    else
    {
     if(isset($this->config["album"])||isset($this->config["tag"]))
     {
      $this->config["listtype"]="List";

      $dc=$this->_getData();

      if(!$this->_cacheDataUpdated($cacheTime, $dc))
       return false;

      $this->config["listtype"]="Photo albums";
     }

     if(isset($this->config["albums"])||isset($this->config["tag"]))
     {
      $dc=$this->_getData();

      if(!$this->_cacheDataUpdated($cacheTime, $dc))
       return false;
     }
    }

    if($this->config["pagebrowser"])
    {
     $dc->setRequestValue("show_from");
     $cacheKey.="_from_".($dc->getValue("show_from")?$dc->getValue("show_from"):0);
    }

    $cacheKey.="_".md5(implode(",", $dc->sortOrder)); //add sorting to cache key
    $cacheKey.=".html";

    //custom _cacheTemplateUpdated
    if($this->config["templatecategories"])
     $time=FS::getTime($_path["project"]["templates"].$this->config["templatecategories"], "modified");
    else
     $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templatecategories, "modified");

    if($cacheTime<$time)
     $cacheTime=$time;

    if($this->config["templatelist"])
     $time=FS::getTime($_path["project"]["templates"].$this->config["templatelist"], "modified");
    else
     $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templatelist, "modified");

    if($cacheTime<$time)
     $cacheTime=$time;

    if($this->config["templateitem"])
     $time=FS::getTime($_path["project"]["templates"].$this->config["templateitem"], "modified");
    else
     $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templateitem, "modified");

    if($cacheTime<$time)
     $cacheTime=$time;

    if($_benchmark) $_benchmark->stop("Last update");
   }
   else if($this->config["listtype"]=="Crumb trail")
   {
    if($_benchmark) $_benchmark->start("Last update");

    $dc=$this->_getData();

    if(!$this->_cacheKey($cacheKey, $dc))
     return false;

    if(!$this->_cacheDataUpdated($cacheTime, $dc))
     return false;

    //custom _cacheTemplateUpdated
    if($this->config["templatecrumbtrail"])
     $time=FS::getTime($_path["project"]["templates"].$this->config["templatecrumbtrail"], "modified");
    else
     $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templatecrumbtrail, "modified");

    if($cacheTime<$time)
     $cacheTime=$time;

    if($_benchmark) $_benchmark->stop("Last update");
   }
   else //normal mode, supported by lister
   {
    if(!parent::cache($cacheTime, $cacheKey))
     return false;

    //additional default templates check
    if($this->config["listtype"]=="Latest pictures") //Latest pictures
    {
     if(!$this->config["templatelist"])
      $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templatelatestpictures, "modified");
    }
    else if($this->config["listtype"]=="Latest comments") //Latest comments
    {
     if(!$this->config["templatelist"])
      $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templatelatestcomments, "modified");
    }
    else //tag cloud templates
    {
     if(!$this->config["templatelist"])
      $time=FS::getTime($this->plugin->path["templates"].$this->plugin->templatecloud, "modified");
    }

    if(isset($time))
     if($cacheTime<$time)
      $cacheTime=$time;
   }

   return true;
  }


  function output()
  {
   if($this->config["listtype"]!="Photo albums")
    return $this->_output();

   $output="";

   //check if album is published
   if(isset($this->config["album"])) //album
   {
    $d=Data::cache("photoalbum_categories", "view", "all");
    $d->clearValues();

    $d->setValue("nr", $this->config["album"]);

    //display published or unpublished if user has edit rights
    $d->setValue("r", "00000000001", 2);
    $d->setOperator("r", "&", 2);
    $d->setOperant("r", "OR", 2);
    $d->setValue("published", true, 2);

    if(!$d->get()||!$d->next())
    {
     $this->e->add("The requested photo album is currently not available", "note");
     return false;
    }
   }

   if(isset($this->config["picture"]))
   {
    $this->config["listtype"]="Item";

    if(($tmp=$this->_output())==false)
     return false;

    $output.=$tmp;
    $this->config["listtype"]="Photo albums";
   }
   else
   {
    if(isset($this->config["album"])||isset($this->config["tag"]))
    {
     $this->config["listtype"]="List";

     if(($tmp=$this->_output())==false)
      return false;

     $output.=$tmp;
     $this->config["listtype"]="Photo albums";
    }

    if(isset($this->config["albums"])||isset($this->config["tag"]))
    {
     if(($tmp=$this->_output())==false)
      return false;

     $output.=$tmp;
    }
   }

   return $output;
  }

  function _output()
  {
   global $_path, $_config, $_benchmark;

   //load categories module for photoalbum_categories::getCategory lookup
   require_once($this->plugin->path["modules"]."categories.php");

   if($_benchmark) $_benchmark->start("Get content");

   if(!($d=$this->_getData()))
    return $this->e->show();

   $id=$d->getID();

   if($this->config["cmspage"]||($this->config["photoalbumpage"]))
   {
    $tmp=Data::cache("pager_categories", "view", "item");

    if($this->config["cmspage"])
    {
     $tmp->setValue("nr", $this->config["cmspagenr"]);
     $tmp->setShowFields("urlname");

     if($tmp->get()&&$tmp->next())
      $cmspage=$tmp->v["urlname"];
     else
      $cmspage=$this->config["cmspagenr"];
    }

    if($this->config["photoalbumpage"])
    {
     $tmp->setValue("nr", $this->config["photoalbumpagenr"]);
     $tmp->setShowFields("urlname");

     if($tmp->get()&&$tmp->next())
      $photoalbumpage=$tmp->v["urlname"];
     else
      $photoalbumpage=$this->config["photoalbumpagenr"];
    }

    unset($tmp);
   }

   $d->addField("sort_order", "text", "show", "control", false, false, implode(",", $d->sortOrder));

   $d->addField("item_url", "text", "", "control", 0);
   if($_config["useModRewrite"]) //mod rewrite
   {
    if($this->config["cmspage"])
     $d->addField("cms_url", "text", "", "control", 0, false, $_path["HTML"]["current"].$cmspage."/");
    else
     $d->addField("cms_url", "text", "", "control", 0);

    $d->addField("base_url", "text", "", "control", 0, false, $_path["HTML"]["current"]);

    $tmp=$_path["HTML"]["current"];
    foreach($this->plugin->vars as $k => $v)
     if($k=="p"||substr($k, 0, 2)=="p[")
      $tmp.=$v."/";

    $d->addField("page_url", "text", "", "control", 0, false, $tmp);

    if($this->config["photoalbumpage"])
     $d->addField("photoalbum_url", "text", "", "control", 0, false, $_path["HTML"]["current"].$photoalbumpage."/");
    else //no specific photoalbum page, use current page
     $d->addField("photoalbum_url", "text", "", "control", 0, false, $tmp);

    unset($tmp);

    $d->addField("automagic_url", "text", "", "control", 0, false, $this->plugin->path["root"]."automagic.php");
   }
   else
   {
    if($this->config["cmspage"])
     $d->addField("cms_url", "text", "", "control", 0, false, $_path["HTML"]["current"].htmlentities("?=".$cmspage."&"));
    else
     $d->addField("cms_url", "text", "", "control", 0);

    if($this->config["photoalbumpage"])
     $d->addField("photoalbum_url", "text", "", "control", 0, false, $_path["HTML"]["current"].htmlentities("?=".$photoalbumpage."&"));
    else //no specific photoalbum page, use current page
     $d->addField("photoalbum_url", "text", "", "control", 0, false, htmlentities($this->plugin->url()));

    $d->addField("base_url", "text", "", "control", 0, false, "");
    $d->addField("page_url", "text", "", "control", 0, false, htmlentities($this->plugin->url()));

    $d->addField("automagic_url", "text", "", "control", 0, false, $this->plugin->path["root"]."automagic.php");
   }

   //get comments category + rights
   if($this->config["listtype"]=="List"||$this->config["listtype"]=="Item")
   {
    //get photo album comments category
    if(!($commentsCatNR=photoalbum_categories::getCategory("comments", $this->config["listcatnr"]))) //not found
    {
     $d->addField("comment_catnr", "nr", "", "control", 0, false, false);
     $d->addField("comment_rights", "boolean", "", "control", false, false, false);
     $d->addField("comment_captcha", "boolean", "", "control", false, false, false);
    }
    else //comments category found
    {
     $d->addField("comment_catnr", "nr", "", "control", 0, false, $commentsCatNR);

     //get comments rights
     $dtmp=Data::cache("categories", "view", "item");
     $dtmp->setShowFields("nr");
     $dtmp->clearValues();

     $dtmp->setValue("nr", $commentsCatNR);

     if($dtmp->get()&&$dtmp->next()&&$dtmp->r("add", "content"))
     {
      $d->addField("comment_rights", "boolean", "", "control", false, false, true);

      if($_config["usernr"]==$_config["anonnr"])
       $d->addField("comment_captcha", "boolean", "", "control", false, false, true);
      else
       $d->addField("comment_captcha", "boolean", "", "control", false, false, false);
     }
     else
      $d->addField("comment_rights", "boolean", "", "control", false, false, false);
    }
   }

   //add album number
   if(isset($this->config["album"])) //album
    $d->addField("albumnr", "nr", "", "control", 0, false, $this->config["album"]);
   else if(isset($this->config["albums"])) //albums
    $d->addField("albumnr", "nr", "", "control", 0, false, $this->config["albums"]);
   else
    $d->addField("albumnr", "nr", "", "control", 0, false, $this->config["listcatnr"]);

   //comment submit items
   $d->addField("comment_text", "text", "", "control", 0, false, "");
   $d->addField("comment_error", "text", "", "control", 0, false, "");

   //previous and next picture markers
   if($this->config["listtype"]=="Item")
   {
    $d->addField("previous_picture", "nr", "", "control");
    $d->addField("next_picture", "nr", "", "control");
   }

   //load template
   if($this->config["listtype"]=="Item") //item template
   {
    if($this->config["templateitem"])
     $templateFile=$_path["project"]["templates"].$this->config["templateitem"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templateitem;
   }
   else if($this->config["listtype"]=="List") //list template
   {
    if($this->config["templatelist"])
     $templateFile=$_path["project"]["templates"].$this->config["templatelist"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templatelist;
   }
   else if($this->config["listtype"]=="Photo albums") //categories template
   {
    if($this->config["templatecategories"])
     $templateFile=$_path["project"]["templates"].$this->config["templatecategories"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templatecategories;
   }
   else if($this->config["listtype"]=="Crumb trail") //crumb trail template
   {
    if($this->config["templatecrumbtrail"])
     $templateFile=$_path["project"]["templates"].$this->config["templatecrumbtrail"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templatecrumbtrail;
   }
   else if($this->config["listtype"]=="Latest pictures") //Latest pictures
   {
    if($this->config["templatelist"])
     $templateFile=$_path["project"]["templates"].$this->config["templatelist"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templatelatestpictures;
   }
   else if($this->config["listtype"]=="Latest comments") //Latest comments
   {
    if($this->config["templatelist"])
     $templateFile=$_path["project"]["templates"].$this->config["templatelist"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templatelatestcomments;
   }
   else //tag cloud templates
   {
    if($this->config["templatelist"])
     $templateFile=$_path["project"]["templates"].$this->config["templatelist"];
    else
     $templateFile=$this->plugin->path["templates"].$this->plugin->templatecloud;
   }

   if($_benchmark) $_benchmark->start("Template");

   $template=new Template($templateFile, true);

   if(!$template->analyze($d))
   {
    $this->e->add($template->e);
    return false;
   }

   if($template->markerExists("_fields")&&$this->config["showfields"]) //_fields marker in template and predefined fields set
    $d->setShowFields(array_merge($this->config["showfields"], $d->check("use", "show"))); //added predefined fields to show fields
   //else //use template defined fields

   if(($this->config["listtype"]=="List"||$this->config["listtype"]=="Item")&&!$d->check("use", "show", "catnr")) //add catnr to show field in list and item mode for item_url
    $d->setShowFields(array_merge(Array("catnr"), $d->check("use", "show")));

   if($_benchmark) $_benchmark->stop("Template");

   if($_benchmark) $_benchmark->start("Get data");

   //get data
   if($this->config["pagebrowser"]||$template->showCount())
    $success=$d->get($template->getLevel(), true);
   else
    $success=$d->get($template->getLevel());

   if(!$success)
   {
    $this->e->add($d->e);
    return false;
   }

   //set sort_order, page_url, base_url and item_url values
   for($c=0;$c<$d->vmax;$c++)
   {
    if($this->config["listtype"]=="List"||$this->config["listtype"]=="Item")
    {
     $d->setDefaultValue("comment_catnr", $c);
     $d->setDefaultValue("comment_rights", $c);
    }

    if($this->commentError&&$d->getValue("nr", $c)==$this->commentEntry)
    {
     $d->setValue("comment_text", $this->commentText, $c);
     $d->setValue("comment_error", $this->commentError, $c);
    }
    else
    {
     $d->setDefaultValue("comment_text", $c);
     $d->setDefaultValue("comment_error", $c);
    }

    $d->setDefaultValue("sort_order", $c);
    $d->setDefaultValue("page_url", $c);
    $d->setDefaultValue("base_url", $c);
    $d->setDefaultValue("cms_url", $c);

    if($this->config["listtype"]=="List")
    {
     if($_config["useModRewrite"]) //mod rewrite
      $d->setValue("item_url", $d->getValue("page_url", $c).$d->getValue("catnr", $c)."/".$d->getValue($id, $c)."/", $c);
     else
      $d->setValue("item_url", $d->getValue("page_url", $c).htmlentities($id."=".$d->getValue($id, $c)."&"), $c);
    }
    else
    {
     if($_config["useModRewrite"]) //mod rewrite
      $d->setValue("item_url", $d->getValue("page_url", $c).$d->getValue("catnr", $c)."/".$d->getValue($id, $c)."/", $c);
     else
      $d->setValue("item_url", $d->getValue("page_url", $c).htmlentities($id."=".$d->getValue($id, $c)."&"), $c);
    }
   }

   //gather previous and next picture
   $template->reset();
   if($template->search("previous_picture", true, true)||$template->search("next_picture", true, true))
   {
    //gather picture ids for this album
    $d2=Data::cache("photoalbum_pictures", "view", "all");
    $d2->clearValues();

    $d2->setValue("catnr", $d->getValue("catnr"));

    $d2->sortOrder("date", "subject");
    $d2->setShowFields();

    if($d2->get())
    {
     $previous=false;
     while($d2->next())
     {
      if($d2->v["nr"]==$d->getValue("nr"))
      {
       if($previous)
        $d->setValue("previous_picture", $previous);

       if($d2->next())
        $d->setValue("next_picture", $d2->v["nr"]);

       break;
      }

      $previous=$d2->v["nr"];
     }
    }
   }


   if($_benchmark) $_benchmark->stop("Get data");
   if($_benchmark) $_benchmark->start("Populate template");

   if($d->e->any("fatal"))
   {
    $this->e->add($d->e);
    return false;
   }

   if(!$template->populate())
   {
    $this->e->add($template->e);
    return false;
   }

   $output=$template->output();

   if($_benchmark) $_benchmark->stop("Populate template");

   if($this->config["pagebrowser"]&&$this->config["listtype"]!="Item"&&$this->config["listtype"]!="Photo albums")
   {
    if($_benchmark) $_benchmark->start("Page browser");

    if($this->config["templatepagebrowser"])
     $templatepagebrowser=new Template($_path["project"]["templates"].$this->config["templatepagebrowser"], true);
    else
     $templatepagebrowser=new Template($this->plugin->path["templates"].$this->plugin->templatepagebrowser, true);

    if($templatepagebrowser->pageBrowser($d, $d->getValue("page_url").(isset($this->config["album"])?$this->config["album"]."/":(isset($this->config["tag"])?$this->config["tag"]."/":"")).($_config["useModRewrite"]?"?":"").(request("sort")?"sort=".$d->getDefaultValue("sort_order")."&amp;":""))) //add ? for args when using mod rewrite
     $output.=$templatepagebrowser->output();

    if($_benchmark) $_benchmark->stop("Page browser");
   }

   if($_benchmark) $_benchmark->stop("Get content");

   return $output;
  }

 }
?>
